/// <reference types="node" resolution-mode="require"/>
import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface ByteAObject {
    value: Buffer;
}
interface ByteA {
    bytea: Buffer;
    value: Buffer;
    postgres: string;
    toString(): string;
    toBuffer(): Buffer;
    toJSON(): ByteAObject;
    equals(string: string): boolean;
    equals(buffer: Buffer): boolean;
    equals(object: ByteA | ByteAObject): boolean;
    safeEquals(string: string): SafeEquals<ByteA>;
    safeEquals(buffer: Buffer): SafeEquals<ByteA>;
    safeEquals(object: ByteA | ByteAObject): SafeEquals<ByteA>;
}
interface ByteAConstructor {
    from(string: string): ByteA;
    from(buffer: Buffer): ByteA;
    from(object: ByteA | ByteAObject): ByteA;
    safeFrom(string: string): SafeFrom<ByteA>;
    safeFrom(buffer: Buffer): SafeFrom<ByteA>;
    safeFrom(object: ByteA | ByteAObject): SafeFrom<ByteA>;
    /**
     * Returns `true` if `object` is a `ByteA`, `false` otherwise.
     */
    isByteA(object: any): object is ByteA;
}
declare const ByteA: ByteAConstructor;
export { ByteA, ByteAConstructor, ByteAObject };
