import type { BigNumber } from "bignumber.js";
import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface Float4Object {
    value: string;
}
interface Float4 {
    float4: BigNumber;
    value: number;
    postgres: string;
    toString(): string;
    toNumber(): number;
    toBigNumber(): BigNumber;
    toJSON(): Float4Object;
    equals(string: string): boolean;
    equals(number: number): boolean;
    equals(bigInt: bigint): boolean;
    equals(bigNumber: BigNumber): boolean;
    equals(object: Float4 | Float4Object): boolean;
    safeEquals(string: string): SafeEquals<Float4>;
    safeEquals(number: number): SafeEquals<Float4>;
    safeEquals(bigInt: bigint): SafeEquals<Float4>;
    safeEquals(bigNumber: BigNumber): SafeEquals<Float4>;
    safeEquals(object: Float4 | Float4Object): SafeEquals<Float4>;
}
interface Float4Constructor {
    from(string: string): Float4;
    from(number: number): Float4;
    from(bigInt: bigint): Float4;
    from(bigNumber: BigNumber): Float4;
    from(object: Float4 | Float4Object): Float4;
    safeFrom(string: string): SafeFrom<Float4>;
    safeFrom(number: number): SafeFrom<Float4>;
    safeFrom(bigInt: bigint): SafeFrom<Float4>;
    safeFrom(bigNumber: BigNumber): SafeFrom<Float4>;
    safeFrom(object: Float4 | Float4Object): SafeFrom<Float4>;
    /**
     * Returns `true` if `object` is a `Float4`, `false` otherwise.
     */
    isFloat4(object: any): object is Float4;
}
declare const Float4: Float4Constructor;
export { Float4, Float4Constructor, Float4Object };
