import type { BigNumber } from "bignumber.js";
import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface Float8Object {
    value: string;
}
interface Float8 {
    float8: BigNumber;
    value: number;
    postgres: string;
    toString(): string;
    toNumber(): number;
    toBigNumber(): BigNumber;
    toJSON(): Float8Object;
    equals(string: string): boolean;
    equals(number: number): boolean;
    equals(bigInt: bigint): boolean;
    equals(bigNumber: BigNumber): boolean;
    equals(object: Float8 | Float8Object): boolean;
    safeEquals(string: string): SafeEquals<Float8>;
    safeEquals(number: number): SafeEquals<Float8>;
    safeEquals(bigInt: bigint): SafeEquals<Float8>;
    safeEquals(bigNumber: BigNumber): SafeEquals<Float8>;
    safeEquals(object: Float8 | Float8Object): SafeEquals<Float8>;
}
interface Float8Constructor {
    from(string: string): Float8;
    from(number: number): Float8;
    from(bigInt: bigint): Float8;
    from(bigNumber: BigNumber): Float8;
    from(object: Float8 | Float8Object): Float8;
    safeFrom(string: string): SafeFrom<Float8>;
    safeFrom(number: number): SafeFrom<Float8>;
    safeFrom(bigInt: bigint): SafeFrom<Float8>;
    safeFrom(bigNumber: BigNumber): SafeFrom<Float8>;
    safeFrom(object: Float8 | Float8Object): SafeFrom<Float8>;
    /**
     * Returns `true` if `object` is a `Float8`, `false` otherwise.
     */
    isFloat8(object: any): object is Float8;
}
declare const Float8: Float8Constructor;
export { Float8, Float8Constructor, Float8Object };
