import type { SafeEquals } from "../../types/SafeEquals.js";
import type { SafeFrom } from "../../types/SafeFrom.js";
interface OIDObject {
    value: number;
}
interface OID {
    oid: number;
    value: number;
    postgres: string;
    toString(): string;
    toNumber(): number;
    toJSON(): OIDObject;
    equals(number: number): boolean;
    equals(string: string): boolean;
    equals(object: OID | OIDObject): boolean;
    safeEquals(number: number): SafeEquals<OID>;
    safeEquals(string: string): SafeEquals<OID>;
    safeEquals(object: OID | OIDObject): SafeEquals<OID>;
}
interface OIDConstructor {
    from(number: number): OID;
    from(string: string): OID;
    from(object: OID | OIDObject): OID;
    safeFrom(number: number): SafeFrom<OID>;
    safeFrom(string: string): SafeFrom<OID>;
    safeFrom(object: OID | OIDObject): SafeFrom<OID>;
    /**
     * Returns `true` if `object` is a `OID`, `false` otherwise.
     */
    isOID(object: any): object is OID;
}
declare const OID: OIDConstructor;
export { OID, OIDConstructor, OIDObject };
