/// <reference types="node" resolution-mode="require"/>
import { type ParseReturnType } from "@postgresql-typed/util";
import type { ParseContext } from "../types/ParseContext.js";
import type { SafeEquals } from "../types/SafeEquals.js";
import { IssueWithoutMessage } from "./PgTPError.js";
export declare abstract class PgTPBase<DataType> {
    constructor();
    abstract value: Record<string, unknown> | unknown[] | string | number | boolean | null | Buffer;
    abstract postgres: string;
    abstract _equals(context: ParseContext): ParseReturnType<{
        readonly equals: boolean;
        readonly data: DataType;
    }>;
    equals(...data: unknown[]): boolean;
    safeEquals(...data: unknown[]): SafeEquals<DataType>;
    private _handleResult;
    setIssueForContext(context: ParseContext, issueData: IssueWithoutMessage): void;
}
