/// <reference types="node" resolution-mode="require"/>
import { Bit, BitVarying, Boolean, Box, ByteA, Character, CharacterVarying, Circle, Date, DateMultiRange, DateRange, Float4, Float8, Int2, Int4, Int4MultiRange, Int4Range, Int8, Int8MultiRange, Int8Range, Interval, JSON, Line, LineSegment, Money, Name, OID as OIDClass, Path, Point, Polygon, Text, Time, Timestamp, TimestampMultiRange, TimestampRange, TimestampTZ, TimestampTZMultiRange, TimestampTZRange, TimeTZ, UUID } from "../index.js";
export declare const defaultParserMappings: {
    17: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1001: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1560: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1561: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1562: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1563: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    16: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1000: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    18: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1002: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1042: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1014: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1043: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1015: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    19: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1003: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    25: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1009: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1082: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1182: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    4535: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | DateMultiRange | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    6155: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | DateMultiRange | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    3912: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | DateRange | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    3913: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | DateRange | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1186: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1187: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1083: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1183: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1114: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1115: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    4533: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | TimestampMultiRange | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    6152: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | TimestampMultiRange | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    3908: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | TimestampRange | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    3909: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | TimestampRange | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1184: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | TimestampTZ | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1185: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | TimestampTZ | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    4534: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    6153: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    3910: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | TimestampTZRange | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    3911: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | TimestampTZRange | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    1266: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | TimeTZ | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1270: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | TimeTZ | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    603: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1020: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    718: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    719: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    628: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    629: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    601: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1018: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    602: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Path | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1019: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Path | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    600: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1017: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    604: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1027: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    114: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    199: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    3802: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    3807: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    790: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    791: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    700: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1021: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    701: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1022: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    21: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1005: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    23: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1007: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    4451: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | Int4MultiRange | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    6150: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | Int4MultiRange | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    3904: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | Int4Range | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    3905: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | Int4Range | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    20: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1016: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    4536: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | Int8MultiRange | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    6157: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | Int8MultiRange | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    3926: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | Int8Range | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    3927: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | Int8Range | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    26: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    1028: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
    2950: {
        serialize: (value: string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null) => string;
        parse: (value: string | null) => ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object> | null;
    };
    2951: {
        serialize: (value: string | (string | number | bigint | boolean | globalThis.Date | import("luxon/src/datetime.js").DateTime | unknown[] | Record<string, unknown> | Buffer | import("../data/Binary/ByteA.js").ByteAObject | ByteA | import("../data/Numeric/Int2.js").Int2Object | Int2 | import("../data/Numeric/Int4.js").Int4Object | Int4 | import("../data/Numeric/Int8.js").Int8Object | Int8 | import("../data/ObjectIdentifier/OID.js").OIDObject | OIDClass | import("../data/Character/Text.js").TextObject | Text | Character<number> | CharacterVarying<number> | Name | UUID | import("../data/Character/CharacterVarying.js").CharacterVaryingObject | import("../data/Character/Character.js").CharacterObject | import("../data/Character/Name.js").NameObject | import("../data/UUID/UUID.js").UUIDObject | Bit<number> | BitVarying<number> | import("../data/BitString/Bit.js").BitObject | import("../data/BitString/BitVarying.js").BitVaryingObject | import("../data/Boolean/Boolean.js").BooleanObject | Boolean | import("../data/DateTime/Time.js").TimeObject | Time | TimestampTZ | import("../data/DateTime/Timestamp.js").TimestampObject | Timestamp | Date | import("../data/DateTime/TimestampTZ.js").TimestampTZObject | import("../data/DateTime/Date.js").DateObject | import("../data/DateTime/TimeTZ.js").TimeTZObject | TimeTZ | import("../data/DateTime/DateRange.js").DateRangeObject | import("../data/DateTime/DateRange.js").RawDateRangeObject | DateRange | import("../data/DateTime/DateMultiRange.js").DateMultiRangeObject | import("../data/DateTime/DateMultiRange.js").RawDateMultiRangeObject | DateMultiRange | import("../data/DateTime/Interval.js").IntervalObject | Interval | import("../data/DateTime/TimestampRange.js").TimestampRangeObject | import("../data/DateTime/TimestampRange.js").RawTimestampRangeObject | TimestampRange | import("../data/DateTime/TimestampMultiRange.js").TimestampMultiRangeObject | import("../data/DateTime/TimestampMultiRange.js").RawTimestampMultiRangeObject | TimestampMultiRange | import("../data/DateTime/TimestampTZRange.js").TimestampTZRangeObject | import("../data/DateTime/TimestampTZRange.js").RawTimestampTZRangeObject | TimestampTZRange | import("../data/DateTime/TimestampTZMultiRange.js").TimestampTZMultiRangeObject | import("../data/DateTime/TimestampTZMultiRange.js").RawTimestampTZMultiRangeObject | TimestampTZMultiRange | import("../data/Enumerated/Enum.js").EnumObject | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | import("../data/Geometric/Box.js").BoxObject | Box | import("../data/Geometric/Circle.js").CircleObject | Circle | import("../data/Geometric/Line.js").LineObject | Line | import("../data/Geometric/Point.js").PointObject | Point | import("../data/Geometric/LineSegment.js").LineSegmentObject | import("../data/Geometric/LineSegment.js").RawLineSegmentObject | LineSegment | [Point, Point] | Point[] | import("../data/Geometric/Path.js").PathObject | import("../data/Geometric/Path.js").RawPathObject | Path | import("../data/Geometric/Polygon.js").PolygonObject | import("../data/Geometric/Polygon.js").RawPolygonObject | Polygon | import("../data/JSON/JSON.js").JSONObject | JSON | import("bignumber.js").BigNumber | import("../data/Monetary/Money.js").MoneyObject | Money | import("../data/Numeric/Float4.js").Float4Object | Float4 | import("../data/Numeric/Float8.js").Float8Object | Float8 | import("../data/Numeric/Int4Range.js").Int4RangeObject | import("../data/Numeric/Int4Range.js").RawInt4RangeObject | Int4Range | import("../data/Numeric/Int4MultiRange.js").Int4MultiRangeObject | import("../data/Numeric/Int4MultiRange.js").RawInt4MultiRangeObject | Int4MultiRange | import("../data/Numeric/Int8Range.js").Int8RangeObject | import("../data/Numeric/Int8Range.js").RawInt8RangeObject | Int8Range | import("../data/Numeric/Int8MultiRange.js").Int8MultiRangeObject | import("../data/Numeric/Int8MultiRange.js").RawInt8MultiRangeObject | Int8MultiRange | TimestampTZRange[] | [TimestampTZ, TimestampTZ] | TimestampRange[] | [Timestamp, Timestamp] | DateRange[] | [Date, Date] | Int4Range[] | [Int4, Int4] | Int8Range[] | [Int8, Int8] | null)[] | null) => string;
        parse: (value: string | null) => (ByteA | Int2 | Int4 | Int8 | OIDClass | Text | Character<number> | CharacterVarying<number> | Name | UUID | Bit<number> | BitVarying<number> | Boolean | Time | Timestamp | Date | import("./Range.js").Range<Date, import("../data/DateTime/Date.js").DateObject> | Interval | import("./Range.js").Range<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("../data/Enumerated/Enum.js").Enum<string, [string, ...string[]]> | Box | Circle | Line | Point | LineSegment | Polygon | JSON | Money | Float4 | Float8 | import("./Range.js").Range<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./Range.js").Range<Int8, import("../data/Numeric/Int8.js").Int8Object> | import("./MultiRange.js").MultiRange<Date, import("../data/DateTime/Date.js").DateObject> | import("./MultiRange.js").MultiRange<Timestamp, import("../data/DateTime/Timestamp.js").TimestampObject> | import("./MultiRange.js").MultiRange<Int4, import("../data/Numeric/Int4.js").Int4Object> | import("./MultiRange.js").MultiRange<Int8, import("../data/Numeric/Int8.js").Int8Object>)[] | null;
    };
};
